#ifndef BGJOB_H
#define BGJOB_H

#include <windows.h>

#include "commdev.h"
#include "msgdef.h"

#define BGJOB_RESULT_SUCCESS  0    // Suggestion for successful processing
#define BGJOB_RESULT_FAILURE  1    // Suggestion for failed processing
#define BGJOB_RESULT_RUNNING  256  // Job is currently running

#define BGJOB_ACTION_EXECUTE  1
#define BGJOB_ACTION_CANCEL   2
typedef WORD(*BGJOBPROC)(struct CommDev *lpDevice, BYTE bAction, LPVOID lpParam);

struct BackgroundJob *CreateBackgroundJob(struct CommDev *lpDevice, BGJOBPROC lpProc, LPVOID lpProcParam);
BOOL SetBackgroundJobOwner(struct BackgroundJob *lpJob, HWND hOwner);
BOOL StartBackgroundJob(struct BackgroundJob *lpJob);
BOOL CancelBackgroundJob(struct BackgroundJob *lpJob);
BOOL WaitForBackgroundJob(struct BackgroundJob *lpJob, DWORD dwTimeout);
void DestroyBackgroundJob(struct BackgroundJob *lpJob);

#endif
