#ifndef DEBUG_H
#define DEBUG_H

#include <assert.h>
#include <stdlib.h>

#ifdef _DEBUG
void Trace(const char *s, ...);
#define TRACE  Trace
#else
#define TRACE(...)
#endif

#ifdef _DEBUG
#define ASSERT(exp)  assert(exp)
#define VERIFY(exp)  assert(exp)
#else
#define ASSERT(exp)
#define VERIFY(exp)  exp
#endif

#ifdef _DEBUG
void *DebugMalloc(size_t n, const char *file, int line);
#define MALLOC(n) DebugMalloc(n, __FILE__, __LINE__)
void DebugFree(void *p, const char *file, int line);
#define FREE(p)   DebugFree(p, __FILE__, __LINE__)
#else
#define MALLOC(n) malloc(n)
#define FREE(p)   free(p)
#endif

#endif
