#include <windows.h>

#include "commproto.h"
#include "protodef.h"

#include "debug.h"

#include "getdriveinfo.h"

LPCSTR GetDriveTypeString(BYTE bDriveType)
{
	static const char *lpDriveTypes[] = { "unknown", "360K", "1.2M", "720K", "1.44M" };
	return lpDriveTypes[(bDriveType < ARRAYSIZE(lpDriveTypes)) ? bDriveType : 0];
}

BOOL GetDriveInfo(HWND hWnd, struct CommDev *lpDevice, BYTE bIndex, struct DriveInfo *lpInfo)
{
	BOOL fResult = FALSE;

#ifdef USE_DUMMY_DRIVE_INFO
	lpInfo->bDriveType = 1;
	lpInfo->bNumberOfTracks = 0x28;
	lpInfo->bNumberOfSectors = 9;
	lpInfo->bNumberOfSides = 2;
	fResult = TRUE;
#else
	struct GetDriveInfoRequest request = { CMD_GET_DRIVE_INFO };
	request.bDriveIndex = bIndex;

	struct GetDriveInfoResponse response;

	WORD wResponseSize = sizeof(response);
	if (ProtocolTransaction(lpDevice, &request, sizeof(request), &response, &wResponseSize))
	{
		lpInfo->bDriveType = response.bDriveType;
		lpInfo->bNumberOfTracks = response.bNumberOfTracks;
		lpInfo->bNumberOfSides = response.bNumberOfSides;
		lpInfo->bNumberOfSectors = response.bNumberOfSectors;
		fResult = TRUE;
	}
#endif

	return fResult;
}
