#ifndef GUIUTILS_H
#define GUIUTILS_H

#include <windows.h>
#include "settings.h"

typedef struct {
	WORD wCtrlId;
	void (*lpHandler)(HWND hDlg, WPARAM wParam);
} CTRL_HANDLER;

void CenterWindow(HWND hWnd, HWND hParent);
void TruncateText(HWND hLabel, LPCSTR lpText, char *lpBuffer, int iBufferSize, UINT uFlags);
const char *GetLastErrorText(void);
int FormatMessageBox(HWND hParent, UINT uType, LPCSTR lpMessage, ...);
void HandleControlMessage(HWND hWnd, WPARAM wParam, const CTRL_HANDLER *lpHandlerList, DWORD dwHandlerCount);
HWND CreateProgressBar(HWND hParent, HWND hPlaceholder);
void PopulateComboBoxDword(HWND hBox, const struct OptionList *lpList, DWORD dwInitialSelectionValue);
void PopulateComboBoxString(HWND hBox, const struct OptionList *lpList, LPCSTR lpInitialSelectionValue);
BOOL GetComboBoxSelectionDword(HWND hBox, LPDWORD lpValue);
BOOL GetComboBoxSelectionString(HWND hBox, CHAR *lpBuffer, DWORD dwSize);

#endif
